%% Copyright (c) Rodolà Emanuele - rodola@in.tum.de 
%  SHREC2016 - Partial Matching Of Deformable Shapes
%  http://www.dais.unive.it/~shrec2016/


function [p, edge_v1, edge_v2, edge_opposite, ret] = check_split(M, match, tri)

ret = 0; % 1: split into three (point is in the triangle)
         % 0: split into two (point is on an edge)

% the sub-vertex in R3
p = match(2)*M.VERT(tri(1),:) + match(3)*M.VERT(tri(2),:) + match(4)*M.VERT(tri(3),:);

on_edge = match(2:4) > 1e-3;
v = find(on_edge);

assert(length(v)>=2);

if length(v)==2 % the sub-vertex is projected onto the closest edge
    edge_v1 = tri(v(1));
    edge_v2 = tri(v(2));
    edge_opposite = tri(~on_edge); % the vertex opposite to the edge
    p = proj_on_edge(p, M.VERT(edge_v1,:), M.VERT(edge_v2,:));
else
    ret = 1;
    edge_v1 = [];
    edge_v2 = [];
    edge_opposite = [];
end

end